Index: cpukit/rtems/Makefile.am
===================================================================
--- cpukit/rtems/Makefile.am	(revision b427a92adfd16e8d68b275b44337f54f6ab0a3ca)
+++ cpukit/rtems/Makefile.am	(revision 1b67535d86c6a92cda1b08759293c20b7fab6978)
@@ -117,4 +117,5 @@
 endif
 librtems_a_SOURCES += src/taskdata.c
+librtems_a_SOURCES += src/schedulergetprocessorset.c
 librtems_a_SOURCES += src/schedulerident.c
 
Index: cpukit/rtems/include/rtems/rtems/tasks.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/tasks.h	(revision b427a92adfd16e8d68b275b44337f54f6ab0a3ca)
+++ cpukit/rtems/include/rtems/rtems/tasks.h	(revision 1b67535d86c6a92cda1b08759293c20b7fab6978)
@@ -566,4 +566,28 @@
 );
 
+#if defined(__RTEMS_HAVE_SYS_CPUSET_H__)
+/**
+ * @brief Gets the set of processors owned by the scheduler.
+ *
+ * @param[in] scheduler_id Identifier of the scheduler.
+ * @param[in] cpusetsize Size of the specified processor set buffer in
+ * bytes.  This value must be positive.
+ * @param[out] cpuset The processor set owned by the scheduler.  A set bit in
+ * the processor set means that this processor is owned by the scheduler and a
+ * cleared bit means the opposite.
+ *
+ * @retval RTEMS_SUCCESSFUL Successful operation.
+ * @retval RTEMS_INVALID_ADDRESS The @a cpuset parameter is @c NULL.
+ * @retval RTEMS_INVALID_ID Invalid scheduler identifier.
+ * @retval RTEMS_INVALID_NUMBER The processor set buffer is too small for the
+ * set of processors owned by the scheduler.
+ */
+rtems_status_code rtems_scheduler_get_processor_set(
+  rtems_id   scheduler_id,
+  size_t     cpusetsize,
+  cpu_set_t *cpuset
+);
+#endif
+
 /**@}*/
 
Index: cpukit/rtems/src/schedulergetprocessorset.c
===================================================================
--- cpukit/rtems/src/schedulergetprocessorset.c	(revision 1b67535d86c6a92cda1b08759293c20b7fab6978)
+++ cpukit/rtems/src/schedulergetprocessorset.c	(revision 1b67535d86c6a92cda1b08759293c20b7fab6978)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2014 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#if HAVE_CONFIG_H
+  #include "config.h"
+#endif
+
+#if defined(__RTEMS_HAVE_SYS_CPUSET_H__)
+
+#include <rtems/rtems/tasks.h>
+#include <rtems/score/cpusetimpl.h>
+#include <rtems/score/schedulerimpl.h>
+
+rtems_status_code rtems_scheduler_get_processor_set(
+  rtems_id   scheduler_id,
+  size_t     cpusetsize,
+  cpu_set_t *cpuset
+)
+{
+  rtems_status_code sc;
+
+  if ( cpuset != NULL ) {
+    const Scheduler_Control *scheduler;
+
+    if ( _Scheduler_Get_by_id( scheduler_id, &scheduler ) ) {
+      if ( _CPU_set_Is_large_enough( cpusetsize ) ) {
+        _Scheduler_Get_processor_set( scheduler, cpusetsize, cpuset );
+
+        sc = RTEMS_SUCCESSFUL;
+      } else {
+        sc = RTEMS_INVALID_NUMBER;
+      }
+    } else {
+      sc = RTEMS_INVALID_ID;
+    }
+  } else {
+    sc = RTEMS_INVALID_ADDRESS;
+  }
+
+  return sc;
+}
+
+#endif /* defined(__RTEMS_HAVE_SYS_CPUSET_H__) */
Index: cpukit/score/include/rtems/score/schedulerimpl.h
===================================================================
--- cpukit/score/include/rtems/score/schedulerimpl.h	(revision b427a92adfd16e8d68b275b44337f54f6ab0a3ca)
+++ cpukit/score/include/rtems/score/schedulerimpl.h	(revision 1b67535d86c6a92cda1b08759293c20b7fab6978)
@@ -462,4 +462,17 @@
 }
 
+RTEMS_INLINE_ROUTINE bool _Scheduler_Get_by_id(
+  Objects_Id                id,
+  const Scheduler_Control **scheduler
+)
+{
+  uint32_t minimum_id = _Scheduler_Build_id( 0 );
+  uint32_t index = id - minimum_id;
+
+  *scheduler = &_Scheduler_Table[ index ];
+
+  return index < _Scheduler_Count;
+}
+
 /** @} */
 
Index: testsuites/sptests/spscheduler01/init.c
===================================================================
--- testsuites/sptests/spscheduler01/init.c	(revision b427a92adfd16e8d68b275b44337f54f6ab0a3ca)
+++ testsuites/sptests/spscheduler01/init.c	(revision 1b67535d86c6a92cda1b08759293c20b7fab6978)
@@ -124,4 +124,56 @@
 }
 
+static void test_scheduler_get_processors(void)
+{
+#if defined(__RTEMS_HAVE_SYS_CPUSET_H__)
+  rtems_status_code sc;
+  rtems_name name = BLUE;
+  rtems_id scheduler_id;
+  cpu_set_t cpusetone;
+  cpu_set_t cpuset;
+  size_t big = 2 * CHAR_BIT * sizeof(cpu_set_t);
+  size_t cpusetbigsize = CPU_ALLOC_SIZE(big);
+  cpu_set_t *cpusetbigone;
+  cpu_set_t *cpusetbig;
+
+  CPU_ZERO(&cpusetone);
+  CPU_SET(0, &cpusetone);
+
+  sc = rtems_scheduler_ident(name, &scheduler_id);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+  sc = rtems_scheduler_get_processor_set(scheduler_id, sizeof(cpuset), NULL);
+  rtems_test_assert(sc == RTEMS_INVALID_ADDRESS);
+
+  sc = rtems_scheduler_get_processor_set(invalid_id, sizeof(cpuset), &cpuset);
+  rtems_test_assert(sc == RTEMS_INVALID_ID);
+
+  sc = rtems_scheduler_get_processor_set(scheduler_id, 0, &cpuset);
+  rtems_test_assert(sc == RTEMS_INVALID_NUMBER);
+
+  sc = rtems_scheduler_get_processor_set(scheduler_id, sizeof(cpuset), &cpuset);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+  rtems_test_assert(CPU_EQUAL(&cpuset, &cpusetone));
+
+  cpusetbigone = CPU_ALLOC(big);
+  rtems_test_assert(cpusetbigone != NULL);
+
+  cpusetbig = CPU_ALLOC(big);
+  rtems_test_assert(cpusetbig != NULL);
+
+  CPU_ZERO_S(cpusetbigsize, cpusetbigone);
+  CPU_SET_S(0, cpusetbigsize, cpusetbigone);
+
+  sc = rtems_scheduler_get_processor_set(scheduler_id, cpusetbigsize, cpusetbig);
+  rtems_test_assert(sc == RTEMS_SUCCESSFUL);
+
+  rtems_test_assert(CPU_EQUAL_S(cpusetbigsize, cpusetbig, cpusetbigone));
+
+  CPU_FREE(cpusetbig);
+  CPU_FREE(cpusetbigone);
+#endif /* defined(__RTEMS_HAVE_SYS_CPUSET_H__) */
+}
+
 static void Init(rtems_task_argument arg)
 {
@@ -134,4 +186,5 @@
   test_task_get_set_affinity();
   test_scheduler_ident();
+  test_scheduler_get_processors();
 
   rtems_test_assert(rtems_resource_snapshot_check(&snapshot));
